%{
/********************************************/
/*          Ada to C++ translator           */
/*  (c) Oct-Nov 1995, Zoran Constantinescu  */
/*       UPB Computer Science  345CB        */
/*  ada2cParser.y  parser description file  */
/********************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "ada2cSimb.h"

extern int line_no;
char *stradd( int, char *, ... );
char err_buff[80];

void * s_attr;
int    s_tip;

attr_var  a_var;
attr_tip  a_tip;
attr_sbpr a_sbpr;

int yylex( );
int yyerror( char * );

_tip un_tip; 
/* lista identificatori */
int nr_id=0;
indexs ids[20];
/* lista parametri proceduri */
int nr_prm=0;
indexs prms[20];
/* lista expresii apel */
int nr_expr;
indexs exprs[20];

int i;
%}


%union {
  char *str;
  _tip  t;
}


%token T_AND T_OR T_XOR T_NOT
%token T_ABS T_MOD T_REM T_ATTRIB
%token T_EQ T_NEQ T_LT T_LE T_GT T_GE
%token T_IF T_THEN T_ELSE T_ELSIF
%token T_ADD T_SUB T_MUL T_DIV T_EXP
%token T_BEGIN T_END T_NULL T_TERM
%token T_INTEGER T_CHARACTER T_BOOLEAN
%token T_LIT_CHAR T_FALSE T_TRUE

%token T_LIT_NUM T_SIR_CHAR T_IDENTIF T_COMMENT
%token T_CONSTANT T_TYPE T_IS T_SUBTYPE T_RANGE T_NEW T_OF
%token T_ARRAY T_OTHERS T_RECORD T_CASE T_WHEN T_REZ
%token T_ACCESS T_IN T_LOOP T_WHILE T_ET_1 T_ET_2 T_SEP_DOM
%token T_FOR T_REVERSE T_DECLARE T_EXCEPTION T_EXIT T_GOTO T_TO
%token T_RETURN T_OUT T_PROCEDURE T_FUNCTION T_PACKAGE T_PRIVATE
%token T_BODY T_LIMITED T_USE T_TASK T_ACCEPT T_DELAY T_SELECT
%token T_ABORT T_TERMINATE T_RAISE T_GENERIC T_WITH T_DIGITS
%token T_DELTA T_SEPARATE T_RENAMES T_PRAGMA T_AT T_ENTRY

%type <str> T_IDENTIF T_COMMENT
%type <t> T_LIT_NUM 
%type <t> tip_date expr expr_bool expr_simpla relatie
%type <str> spec_param prog parte_decl lista_identif lista_expr
%type <str> spec_subprg corp_subprg spec_proc spec_func decl_obiect
%type <str> decl_subprg declaratie instr_apel lista_param
%type <str> instr tip_instr instr_null instr_atrib instr_if elsif
%type <str> instr_case altrn_case crit_sel instr_goto instr_exit
%type <str> instr_loop instr_loop1 schema_iter instr_return
%type <str> op_unar op_aditiv op_multipl op_relat op_logic op_aritm

%start main

%%

main:  prog   { printf("%s",$1); free($1); }
      ;

prog:  prog decl_subprg  {
         $$=stradd(4,$1,"\n$\n",$2,";\n@\n");
         free($1); free($2); }
     | prog corp_subprg  {
         $$=stradd(4,$1,"\n$\n",$2,"@\n");
         free($1); free($2); }
     | prog T_COMMENT  {
         $$=stradd(4,$1,"\n/* ",$2," */\n");
         free($1); free($2); }
     |   { $$=stradd(1,""); }
     ;

 /* specificatie subprogram */
decl_subprg:  spec_subprg T_TERM  { $$=$1; }
            ;

spec_subprg:  spec_proc  { $$=$1; }
            | spec_func  { $$=$1; }
            ;

spec_proc:  T_PROCEDURE T_IDENTIF  { 
              a_sbpr.nr_param=0;
              a_sbpr.list_param=NULL;
              a_sbpr.tip_rez=-1;
              add_simb($2,S_SBPR,new_at_sbpr(a_sbpr));
              $$=stradd(3,"void ",$2,"( )");
              free($2); }
          | T_PROCEDURE T_IDENTIF '(' lista_param ')'  {
              a_sbpr.nr_param=nr_prm;
              a_sbpr.list_param=(indexs *)malloc(nr_prm*sizeof(indexs));
              for (i=0;i<nr_prm;i++)
                a_sbpr.list_param[i]=prms[i];
              a_sbpr.tip_rez=-1;
              add_simb($2,S_SBPR,new_at_sbpr(a_sbpr));
              nr_prm=0;
              $$=stradd(5,"void ",$2,"( ",$4," )");
              free($2); free($4); }
          ;

spec_func:  T_FUNCTION T_IDENTIF T_RETURN tip_date  {
              a_sbpr.nr_param=0;
              a_sbpr.list_param=NULL;
              a_sbpr.tip_rez=$4.tip;
              add_simb($2,S_SBPR,new_at_sbpr(a_sbpr));
              $$=stradd(4,$4.str," ",$2,"( )");
              free($4.str); free($2); }
          | T_FUNCTION T_IDENTIF '(' lista_param ')' T_RETURN tip_date  {
              a_sbpr.tip_rez=$7.tip;
              a_sbpr.nr_param=nr_prm;
              a_sbpr.list_param=(indexs *)malloc(nr_prm*sizeof(indexs));
              for (i=0;i<nr_prm;i++)
                a_sbpr.list_param[i]=prms[i];
              add_simb($2,S_SBPR,new_at_sbpr(a_sbpr));
              nr_prm=0;
              $$=stradd(6,$7.str," ",$2,"( ",$4," )");
              free($7.str); free($2); free($4); }
          ;

corp_subprg:  spec_subprg T_IS parte_decl T_BEGIN instr T_END T_TERM {
                $$=stradd(6,$1,"\n{\n$\n",$3,"@\n",$5,"}\n");
                free($1); free($3); free($5); }
            ; 

parte_decl:  parte_decl declaratie  {
               $$=stradd(2,$1,$2);
               free($1); free($2); }
           | declaratie  { $$=$1; }
           |   { $$=stradd(1,""); }
           ;

declaratie:  corp_subprg  { $$=$1; }
           | decl_obiect  { $$=$1; }
           ;

decl_obiect:  lista_identif ':' tip_date T_TERM  {
                a_var.tip=$3.tip;
                a_var.tipv=T_VAR;
                fill_at_var(nr_id,ids,a_var);
                $$=stradd(4,$3.str," ",$1," ;\n");
                nr_id=0;
                free($1); free($3.str); }
            | lista_identif ':' T_CONSTANT tip_date T_TERM  {
                a_var.tip=$4.tip;
                a_var.tipv=T_CONST;
                fill_at_var(nr_id,ids,a_var);
                $$=stradd(5,"const ",$4.str," ",$1," ;\n");
                nr_id=0;
                free($1); free($4.str); }
            ;

lista_identif:  lista_identif ',' T_IDENTIF  {
                  ids[nr_id++]=add_simb($3,S_VAR,NULL)-1;
                  $$=stradd(3,$1,", ",$3);
                  free($1); free($3); }
              | T_IDENTIF  { 
                  ids[nr_id++]=add_simb($1,S_VAR,NULL)-1;
                  $$=$1; }
              ;

lista_expr:  lista_expr ',' expr  {
               exprs[nr_expr++]=$3.tip;
               $$=stradd(3,$1,", ",$3.str);
               free($1); free($3.str); }
           | expr  { 
               exprs[nr_expr++]=$1.tip;
               $$=$1.str; }
           ;

lista_param:  lista_param T_TERM spec_param  {
                $$=stradd(3,$1,", ",$3);
                free($1); free($3); }
            | spec_param  { 
                $$=$1; }
            ;

spec_param:  lista_identif ':' tip_date  {
               a_var.tip=$3.tip;
               a_var.tipv=T_PARAM;
               fill_at_var(nr_id,ids,a_var);
               $$=stradd(3,$3.str," ",$1);
               for (i=0;i<nr_id;i++)
                 prms[nr_prm++]=ids[i];
               nr_id=0;
               free($3.str); free($1); }
           ;

tip_date:  T_INTEGER    { 
             un_tip.str=stradd(1,"int");
             un_tip.tip=find_simb("integer",&s_tip,&s_attr);
             $$=un_tip; }
         | T_CHARACTER  {
             un_tip.str=stradd(1,"char");
             un_tip.tip=find_simb("character",&s_tip,&s_attr);
             $$=un_tip; }
         | T_BOOLEAN    {
             un_tip.str=stradd(1,"Boolean");
             un_tip.tip=find_simb("boolean",&s_tip,&s_attr);
             $$=un_tip; }
         | T_IDENTIF    {
             if ((un_tip.tip=find_simb($1,&s_tip,&s_attr))==-1)
               {
                 sprintf(err_buff,"'%s'  tip nedefinit",$1);
                 yyerror(err_buff);
               } 
             un_tip.str=$1; 
             $$=un_tip; }
         ;

instr:  instr tip_instr  {
          $$=stradd(4,$1,"$\n",$2,"@\n");
          free($1); free($2); }
      | tip_instr  { 
          $$=stradd(3,"$\n",$1,"@\n");
          free($1); }
      ;

tip_instr:  instr_null   { $$=$1; }
          | instr_if     { $$=$1; }
          | instr_atrib  { $$=$1; }
          | instr_case   { $$=$1; }
          | instr_goto   { $$=$1; }
          | instr_loop   { $$=$1; }
          | instr_return { $$=$1; }
          | instr_exit   { $$=$1; }
          | instr_apel   { $$=$1; }
          | T_ET_1 T_IDENTIF T_ET_2 tip_instr  {
              add_simb($2,S_ETICH,NULL);
              $$=stradd(4,$2,": \n$\n",$4,"@\n");
              free($2); free($4); }
          ;

instr_null:  T_NULL T_TERM  { $$=stradd(1," ;\n"); }
           ;

instr_atrib:  T_IDENTIF T_ATTRIB expr T_TERM  {
                if (find_simb($1,&s_tip,&s_attr)==-1)
                  {
                    sprintf(err_buff,"'%s'  variabila nedeclarata",$1);
                    yyerror(err_buff);
                  }
                else if (s_tip!=S_VAR)
                  {
                    sprintf(err_buff,"'%s'  nu este variabila",$1);
                    yyerror(err_buff);
                  }
                else if (((attr_var *)s_attr)->tip!=$3.tip)
                  {
                    sprintf(err_buff,"'%s'  tip incompatibil",$1);
                    yyerror(err_buff);
                  }
                $$=stradd(4,$1," = ",$3.str," ;\n");
                free($1); free($3.str); }
            ;
          
instr_if:  T_IF expr_bool T_THEN instr T_END T_IF T_TERM  {
             $$=stradd(5,"if ( ",$2.str," )\n$\n{\n",$4,"}\n@\n");
             free($2.str); free($4); }
         | T_IF expr_bool T_THEN instr T_ELSE instr T_END T_IF T_TERM  {
             $$=stradd(8,"if ( ",$2.str," )\n$\n{\n",$4,"}\n@\n",
                         "else\n$\n{\n",$6,"}\n@\n");
             free($2.str); free($4); free($6); }
         | T_IF expr_bool T_THEN instr elsif T_END T_IF T_TERM  {
             $$=stradd(6,"if ( ",$2.str," )\n$\n{\n",$4,"}\n@\n",$5);
             free($2.str); free($4); free($5); }
         | T_IF expr_bool T_THEN instr elsif T_ELSE instr T_END T_IF T_TERM  {
             $$=stradd(9,"if ( ",$2.str," )\n$\n{\n",$4,"}\n@\n",$5,
                         "else\n$\n{\n",$7,"}\n@\n");
             free($2.str); free($4); free($5); free($7); }
         ;   

elsif:  elsif elsif  {
          $$=stradd(2,$1,$2);
          free($1); free($2); }
      | T_ELSIF expr_bool T_THEN instr  {
          $$=stradd(5,"else if ( ",$2.str," )\n$\n{\n",$4,"}\n@\n");
          free($2.str); free($4); }
      |  { $$=stradd(1,""); }
      ;

instr_case:  T_CASE expr T_IS altrn_case T_END T_CASE T_TERM  {
               $$=stradd(5,"switch (",$2.str,") {\n$\n",$4,"@\n}\n");
               free($2.str); free($4); }
           ;    

altrn_case:  altrn_case altrn_case  {
               $$=stradd(2,$1,$2);
               free($1); free($2); }
           | T_WHEN crit_sel T_REZ instr  {
               $$=stradd(4,$2,"$\n{\n",$4,"$\nbreak;\n@\n}\n@\n");
               free($2); free($4); }
           ;

crit_sel:  crit_sel '|' crit_sel  {
             $$=stradd(2,$1,$3);
             free($1); free($3); }
         | expr  {
             $$=stradd(3,"case ",$1.str," :\n");
             free($1.str); }
         | T_OTHERS  { $$=stradd(1,"default :\n"); }
         ;

instr_goto:  T_GOTO T_IDENTIF T_TERM  {
               if (find_simb($2,&s_tip,&s_attr)==-1)
                 {
                   sprintf(err_buff,"'%s'  eticheta inexistenta",$2);
                   yyerror(err_buff);
                 }
               else if(s_tip!=S_ETICH)
                 {
                   sprintf(err_buff,"'%s'  nu este eticheta",$2);
                   yyerror(err_buff);
                 }
               $$=stradd(3,"goto ",$2," ;\n"); }
           ;    

instr_loop:  T_IDENTIF ':' instr_loop1 T_IDENTIF T_TERM  {
               if (strcmp($1,$4))
                 {
                   sprintf(err_buff,"'%s'  difera numele de start/end al buclei",$1);
                   yyerror(err_buff);
                 }
               add_simb($1,S_LOOP,NULL);
               $$=stradd(4,"/* Instr. loop: ",$1," */\n",$3);
               free($1); free($3); free($4); }
           | instr_loop1 T_TERM  { $$=$1; }
           ;

instr_loop1:  schema_iter instr T_END T_LOOP  {
                $$=stradd(4,$1,"$\n{\n",$2,"}\n@\n");
                free($1); free($2); }
            ;

schema_iter:  T_WHILE expr_bool T_LOOP  {
                $$=stradd(3,"while (",$2.str,")\n");
                free($2.str); }
            | T_FOR T_IDENTIF T_IN T_LIT_NUM T_SEP_DOM T_LIT_NUM T_LOOP  {
                add_simb($2,S_VAR,NULL);
                $$=stradd(11,"for (",$2,"=",$4.str,";",$2,"<=",$6.str,";",$2,"++)\n");
                free($2); free($4.str); free($6.str); }
            | T_FOR T_IDENTIF T_IN T_REVERSE T_LIT_NUM T_SEP_DOM T_LIT_NUM T_LOOP  {
                add_simb($2,S_VAR,NULL);
                $$=stradd(11,"for (",$2,"=",$7.str,";",$2,"<=",$5.str,";",$2,"--)\n");
                free($2); free($5.str); free($7.str); }
            | T_LOOP  { $$=stradd(1,"while (1)\n"); }
            ;

instr_return:  T_RETURN T_TERM  { $$=stradd(1,"return ;\n"); }
             | T_RETURN expr T_TERM  {
                 $$=stradd(3,"return ",$2.str," ;\n");
                 free($2.str); }
             ;

instr_exit:  T_EXIT T_TERM  { $$=stradd(1,"break ;\n"); }
           | T_EXIT T_IDENTIF T_TERM  {
               add_simb($2,S_EXIT,NULL);
               $$=stradd(3,"/* Instr. exit: ",$2," */\n  break ;\n"); 
               free($2); }
           | T_EXIT T_WHEN expr_bool T_TERM  {
               $$=stradd(3,"if (",$3.str,")  break ;\n"); 
               free($3.str); }
           | T_EXIT T_IDENTIF T_WHEN expr_bool T_TERM  {
               add_simb($2,S_EXIT,NULL);
               $$=stradd(5,"/* Instr. exit: ",$2," */\n   if (",
                           $4.str,")  break ;\n");
               free($2); free($4.str); } 
           ;

instr_apel:  T_IDENTIF T_TERM  {
               if (find_simb($1,&s_tip,&s_attr)==-1)
                 {
                   sprintf(err_buff,"'%s'  apel procedura nedeclarata",$1);
                   yyerror(err_buff);
                 }
               else if (s_tip!=S_SBPR)  
                 {
                   sprintf(err_buff,"'%s'  nu este procedura",$1);
                   yyerror(err_buff);
                 }
               else if (((attr_sbpr *)s_attr)->nr_param!=0)  
                 {
                   sprintf(err_buff,"'%s'  nu are nici un parametru",$1);
                   yyerror(err_buff);
                 }
               $$=stradd(2,$1," ;"); 
               free($1); }
           | T_IDENTIF '(' lista_expr ')' T_TERM  {
               if (find_simb($1,&s_tip,&s_attr)==-1)
                 {
                   sprintf(err_buff,"'%s'  apel procedura nedeclarata",$1);
                   yyerror(err_buff);
                 }
               if (s_tip!=S_SBPR)  
                 {
                   sprintf(err_buff,"'%s'  nu este procedura",$1);
                   yyerror(err_buff);
                 }
               if (((attr_sbpr *)s_attr)->nr_param!=nr_expr)  
                 {
                   sprintf(err_buff,"'%s'  nr. incorect de parametri",$1);
                   yyerror(err_buff);
                 }
               for (i=0;i<nr_expr;i++)
                 if (exprs[i]!=((attr_sbpr *)s_attr)->list_param[i])
                   {
                     sprintf(err_buff,"'%s'  tipuri parametri inconsistente",$1);
                     yyerror(err_buff);
                   }
               nr_expr=0;
               $$=stradd(2,$1," ;"); 
               free($1); }
           ;


expr:  expr_bool  { $$=$1; }
     | expr_simpla  { $$=$1; }
     ;

expr_bool:  expr_bool op_logic expr_bool  {
              if ($1.tip!=$3.tip)
                {
                  sprintf(err_buff,"'%s'  tipuri incompatibile",$1.str);
                  yyerror(err_buff);
                }
              $$.str=stradd(3,$1.str,$2,$3.str);
              $$.tip=$1.tip;
              free($1.str); free($2); free($3.str); }
          | expr_bool T_XOR expr_bool  {
              if ($1.tip!=$3.tip)
                {
                  sprintf(err_buff,"'%s'  tipuri incompatibile",$1.str);
                  yyerror(err_buff);
                }
              $$.tip=$1.tip;
              $$.str=stradd(9,"( ((",$1.str,")&&!(",$3.str,")) || (!(",$1.str,")&&(",$3.str,")) )");
              free($1.str); free($3.str); }
          | '(' expr_bool ')'  {
              $$.tip=$2.tip;
              $$.str=stradd(3,"( ",$2.str," )");
              free($2.str); }
          | relatie  { $$=$1; }
          ;

relatie:  expr_simpla op_relat expr_simpla  {
            if ($1.tip!=$3.tip)
              {
                sprintf(err_buff,"'%s'  tipuri incompatibile",$1.str);
                yyerror(err_buff);
              }
            $$.tip=3;  /* boolean */
            $$.str=stradd(3,$1.str,$2,$3.str);
            free($1.str); free($2); free($3.str); }
        ;

expr_simpla:  expr_simpla op_aritm expr_simpla  {
                if ($1.tip!=$3.tip)
                  {
                    sprintf(err_buff,"'%s'  tipuri incompatibile",$1.str);
                    yyerror(err_buff);
                  }
                $$.tip=$1.tip;
                $$.str=stradd(3,$1.str,$2,$3.str);
                free($1.str); free($2); free($3.str); }
            | expr_simpla T_EXP expr_simpla  {
                if ($1.tip!=$3.tip)
                  {
                    sprintf(err_buff,"'%s'  tipuri incompatibile",$1.str);
                    yyerror(err_buff);
                  }
                $$.tip=$1.tip;
                $$.str=stradd(5,"pow( ",$1.str,", ",$3.str," )");
                free($1.str); free($3.str); }
            | op_unar expr_simpla  {
                $$.tip=$2.tip;
                $$.str=stradd(2,$1,$2.str);
                free($1); free($2.str); }
            | '(' expr_simpla ')'  {
                $$.tip=$2.tip;
                $$.str=stradd(3,"( ",$2.str," )");
                free($2.str); }
            | T_LIT_NUM  { $$=$1; }
            | T_IDENTIF  { 
                if (find_simb($1,&s_tip,&s_attr)==-1)
                  {
                    sprintf(err_buff,"'%s'  variabila nedeclarata",$1);
                    yyerror(err_buff);
                  }
                else if (s_tip!=S_VAR)
                  {
                    sprintf(err_buff,"'%s'  nu este variabila",$1);
                    yyerror(err_buff);
                  }
                $$.tip=((attr_var *)s_attr)->tip;
                $$.str=$1; }
            | T_IDENTIF '(' ')'  {
                if (find_simb($1,&s_tip,&s_attr)==-1)
                  {
                    sprintf(err_buff,"'%s'  functie nedeclarata",$1);
                    yyerror(err_buff);
                  }
                else if (s_tip!=S_SBPR || ((attr_sbpr *)s_attr)->tip_rez==-1 )
                  {
                    sprintf(err_buff,"'%s'  nu este functie",$1);
                    yyerror(err_buff);
                  }
                else if ( ((attr_sbpr *)s_attr)->nr_param!=0 )  
                  {
                    sprintf(err_buff,"'%s'  lipsa parametri",$1);
                    yyerror(err_buff);
                  }
                $$.str=stradd(3,$1,"(",")");
                $$.tip=((attr_sbpr *)s_attr)->tip_rez;
                free($1); }
            | T_IDENTIF '(' lista_expr ')'  {
                if (find_simb($1,&s_tip,&s_attr)==-1)
                  {
                    sprintf(err_buff,"'%s'  functie nedeclarata",$1);
                    yyerror(err_buff);
                  }
                else if (s_tip!=S_SBPR || ((attr_sbpr *)s_attr)->tip_rez==-1 )
                  {
                    sprintf(err_buff,"'%s'  nu este functie",$1);
                    yyerror(err_buff);
                  }
                else if ( ((attr_sbpr *)s_attr)->nr_param==0 )  
                  {
                    sprintf(err_buff,"'%s'  prea multi parametri",$1);
                    yyerror(err_buff);
                  }
                for (i=0;i<nr_expr;i++)
                  if (exprs[i]!=((attr_sbpr *)s_attr)->list_param[i])
                    {
                      sprintf(err_buff,"'%s'  tipuri parametri inconsistente",$1);
                      yyerror(err_buff);
                    }
                $$.str=stradd(4,$1,"(",$3,")");
                nr_expr=0;
                free($1); free($3); }
            ;
      
op_unar:  T_ADD { $$=stradd(1," + "); }
        | T_SUB { $$=stradd(1," - "); } 
        | T_NOT { $$=stradd(1," ! "); }
        | T_ABS { $$=stradd(1," abs "); }
        ;

op_aritm:  op_aditiv  { $$=$1; }
         | op_multipl { $$=$1; }
         ;

op_aditiv:  T_ADD { $$=stradd(1," + "); }
          | T_SUB { $$=stradd(1," - "); }
          ;

op_multipl:  T_MUL { $$=stradd(1," * "); }
           | T_DIV { $$=stradd(1," / "); }
           | T_MOD { $$=stradd(1," % "); }
           | T_REM { $$=stradd(1," %% "); }
           ;          

op_relat:  T_EQ { $$=stradd(1," == "); }
         | T_NEQ { $$=stradd(1," != "); }
         | T_LT { $$=stradd(1," < "); }
         | T_LE { $$=stradd(1," <= "); }
         | T_GT { $$=stradd(1," > "); }
         | T_GE { $$=stradd(1," >= "); }
         ;

op_logic:  T_AND { $$=stradd(1," && "); }
         | T_OR { $$=stradd(1," || "); }
         | T_AND T_THEN { $$=stradd(1," && "); }
         | T_OR T_ELSE { $$=stradd(1," || "); }
         ;

%%

char *stradd( int n, char *s1, ... )
{
  int i, x=0 ;
  char *tmp, *str;
  for (i=0;i<n;i++)
    x+=strlen(*(char **)((char *)&s1+i*sizeof(char *)));
  str=(char *)malloc((x+1)*sizeof(char));
  strcpy(str,"");
  for (i=0;i<n;i++) {
    tmp=*(char **)((char *)&s1+i*sizeof(char *));
    strcpy(str+strlen(str),tmp);
  }
  return str; 
}

