/********************************************/
/*          Ada to C++ translator           */
/*  (c) Oct-Nov 1995, Zoran Constantinescu  */
/*       UPB Computer Science  345CB        */
/* ada2cSimb.c  simbol table utilities file */
/********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ada2cSimb.h>

/* tabela de simboluri */
str_simb *tab_simb[MAX_SIMB];
int nr_simb=0;

int add_simb( char *name, int type, void *attrib )
{
  str_simb *tmp;
  if (nr_simb>MAX_SIMB) 
    return -1;
  tmp=(str_simb *)malloc(sizeof(str_simb));
  tab_simb[nr_simb]=tmp;
  tmp->idx_simb=nr_simb;
  tmp->num_simb=(char *)malloc(strlen(name)+1);
  strcpy(tmp->num_simb,name);
  tmp->tip_simb=type;
  tmp->attr_simb=attrib;
  return ++nr_simb;
}

int find_simb(char *name, int *type, void **attrib)
{
  int i=0;
  while (i<nr_simb)
    if (!strcmp(name,tab_simb[i]->num_simb))
      {
        *type=tab_simb[i]->tip_simb;
        *attrib=tab_simb[i]->attr_simb;
        return i;
      }
    else
      i++;
  return -1;
}

int init_simb()
{
  int tip;
  void *attr;
  attr_var *v;

  add_simb("integer",S_TIP,NULL);
  add_simb("character",S_TIP,NULL);
  add_simb("float",S_TIP,NULL);
  add_simb("boolean",S_TIP,NULL);

  return 0;
}


int list_simb(char *file)
{
  FILE *fd;
  int i,h;
  attr_var  *a_var;
  attr_tip  *a_tip;
  attr_sbpr *a_sbpr;
  char tip_s[6][8]={ "S_VAR  ", "S_SBPR ", "S_TIP  ", 
                     "S_ETICH", "S_EXIT ", "S_LOOP " };
  char tip_v[3][8]={ "T_CONST", "T_VAR  ", "T_PARAM" };

  fd=fopen(file,"w+t");

  fprintf(fd,"  nr.  |  nume_simbol  | tip_simbol |  attrib_simb \n");
  fprintf(fd,"------------------------------------------------------------\n");

  for (i=0;i<nr_simb;i++)
    {
      fprintf(fd,"  %3d  |  %11s  |   %7s  |  ", tab_simb[i]->idx_simb,
                 tab_simb[i]->num_simb, tip_s[tab_simb[i]->tip_simb] );
      switch (tab_simb[i]->tip_simb) 
        {
          case S_VAR  :  if (!(tab_simb[i]->attr_simb) )
                           fprintf(fd,"...\n"); 
                         else 
                           {
                             a_var=(attr_var *)(tab_simb[i]->attr_simb);
                             fprintf(fd,"var=%s tip=%s \n",
                               tip_v[a_var->tipv],
                               (a_var->tip==-1)?"-1":tab_simb[a_var->tip]->num_simb);
                           }
                         break;
          case S_SBPR :  if (!(tab_simb[i]->attr_simb) )
                           fprintf(fd,"...\n"); 
                         else 
                           {
                             a_sbpr=(attr_sbpr *)(tab_simb[i]->attr_simb);
                             fprintf(fd,"tip=%s param=%d ",
                               (a_sbpr->tip_rez==-1)?"-1":tab_simb[a_sbpr->tip_rez]->num_simb,
                               a_sbpr->nr_param);
                             for (h=0;h<((a_sbpr->nr_param)-1);h++)
                               fprintf(fd,"%s,",tab_simb[a_sbpr->list_param[h]]->num_simb);
                             if (a_sbpr->nr_param!=0)
                               fprintf(fd,"%s",tab_simb[a_sbpr->list_param[h]]->num_simb);
                             fprintf(fd,"\n");  
                           }
                         break;
          case S_TIP  :  if (!(tab_simb[i]->attr_simb) )
                           fprintf(fd,"...\n"); 
                         else 
                           {
                             a_tip=(attr_tip *)(tab_simb[i]->attr_simb);
                             fprintf(fd," \n");
                           }
                         break;
          case S_ETICH:
          case S_LOOP :
          case S_EXIT :  fprintf(fd,"*  \n");
                         break;
        }
    }

  fclose(fd);

  return 0;
}

attr_sbpr *new_at_sbpr( attr_sbpr at )
{
  attr_sbpr *nat;

  nat=(attr_sbpr *)malloc(sizeof(attr_sbpr));
  memcpy(nat,&at,sizeof(attr_sbpr));
  return nat;
}

int fill_at_var( int nr_var, indexs *list_var, attr_var at )
{
  int i;
  attr_var *nat;

  for (i=0;i<nr_var;i++)
    {
      nat=(attr_var *)malloc(sizeof(attr_var));
      memcpy(nat,&at,sizeof(attr_var));
      tab_simb[list_var[i]]->attr_simb=nat;
    }
  return 0;
}
