/********************************************/
/*          Ada to C++ translator           */
/*  (c) Oct-Nov 1995, Zoran Constantinescu  */
/*       UPB Computer Science  345CB        */
/*  ada2cParser.y  parser description file  */
/*  ada2cSimb.h   simbol table description  */
/********************************************/
#ifndef _ADA2CSIMB_H
#define _ADA2CSIMB_H

#define T_CONST  0
#define T_VAR    1
#define T_PARAM  2

#define S_VAR    0         /* variabila, parametru, constanta */
#define S_SBPR   1         /* functie, procedura */
#define S_TIP    2         /* tip de date */
#define S_ETICH  3         /* eticheta */
#define S_EXIT   4         /* nume bloc exit */
#define S_LOOP   5         /* nume bucla loop */

typedef int indexs;

typedef struct _attr_var  {
  indexs tip;                       /* tipul variabilei */
  indexs dom_val;                   /* domeniu de valabilitate */
  int tipv;                         /* T_CONST, T_VAR, T_PARAM */
} attr_var;

typedef struct _attr_sbpr  {
  int nr_param;                     /* nr. de parametri */
  indexs *list_param;               /* tipurile de parametri */
  indexs tip_rez;                   /* tipul rezultatului, -1=proc */
} attr_sbpr;

typedef struct _attr_tip  {

} attr_tip;

/* o intrare in tabela de simboluri */
typedef struct _str_simb  {      
  indexs  idx_simb;                   /* indexul simbolului */
  char *  num_simb;                   /* numele simbolului */
  int     tip_simb;                   /* tipul simbolului S_XXXX */ 
  void * attr_simb;                   /* atributul simbolului */
} str_simb;

#define MAX_SIMB 100

/* adauga un simbol in tabela */
int add_simb ( char *nume, int  tip, void * attrib );
/* cauta un simbol in tabela si intoarce indexul daca exista sau -1 */
int find_simb( char *nume, int *tip, void **attrib );
/* adauga in tabela tipurile integer,character,float,boolean */
int init_simb( );
/* listeaza tabela intr-un fisier */
int list_simb( char *filename );

/* copiza atributul dat ca parametru alocindu-i spatiu */
attr_sbpr *new_at_sbpr( attr_sbpr );
attr_tip  *new_at_tip( attr_tip );
attr_var  *new_at_var( attr_var );

/* pt. lista de variabile data printr-un vector de indecsi completeaza attr */
int fill_at_var( int nr_var, indexs *list_var, attr_var atr );

extern str_simb *tab_simb[MAX_SIMB];
extern int nr_simb;


typedef struct {
  char *str;
  indexs tip;
} _tip;


#endif
